#!perl

# Italian model for the AG-MEMOD project


&get_input;
&load_files;
&run_model;
&html_out;

#####################################################################
sub get_input {
use CGI qw(:standard);
    $query = new CGI;
	$outvar = $query->param('outvar');
	$country = $query->param('country');
	if ($outvar eq "- - - - - -") {&error('Please select a variable name');}

	if ($country eq "Italy") {
      $file_parameters = "../parametri/it_model_parameters.txt";
      $file_data       = "../dati/it_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	}
	if ($country eq "EU11_OliveOilDemand") {
      $file_parameters = "../parametri/eu11_model_parameters.txt";
      $file_data       = "../dati/eu11_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	}

}

#################################################################
sub load_files {
	#Open data database
    open (DATA, "<$file_data");
    @hisdatas1=(<DATA>);
    close DATA;
	@testone = @hisdatas1;

	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $hisdata(@hisdatas1){
          if ($hisdata ne "\n") {
			 # I remove all the blanks
             $hisdata =~ s/ //g;
		     # I change the commas, if presents, with the dot
             if ($data_delimiter ne ",") {$hisdata =~ s/,/./g;}
		     # I change all the letters in lower case
             $hisdata =~ tr/A-Z/a-z/;
             @dat = split (/$data_delimiter/, $hisdata);
	           if (@dat[0] !~ /$comment_key/ && @dat[0] ne "") {
                    push @hisdatas, $hisdata;
	            }
			}
          }

    # I load the data
    foreach $hisdata(@hisdatas){
       @dat = split (/$data_delimiter/, $hisdata);
	      $n_values = scalar (@dat); 
		  $i=1;
		  while ($i<$n_values) {
             push @{@dat[0]}, @dat[$i];
			 $i++;
		  }
    }
}

######################################################################
sub run_model {

    $n_years = scalar @year;
    $ystart_xxxx = @year[0];
	$yend_xxxx = @year[$n_years-1];
	$outvar_min = $outvar;
	$outvar_min =~ tr/A-Z/a-z/;
	$outvar_testeq = "$outvar_min"."_est";
	@outvar_obs = @{$outvar_min};
	for ($y=0;$y<($n_years-1);$y++) {
<<INSERT-HERE>>
	}
	if (@{$outvar_testeq}) {$outvar_min = $outvar_testeq;}
}
##########################################################################
sub html_out {
  print "Content-type: text/html\n\n";
  print "<html><body>\n";
  print "<hr>AG-MEMOD - Italian Model<br><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font><br><hr>\n";
  print "<table>\n";
  print "<tr><td>Variable:&nbsp;</td><td><b>$outvar</b></td></tr>\n";
  print "<tr><td>Country:&nbsp;</td><td>$country</td></tr>\n";
  if ($method eq "all") {$method_descr="Simultaneous running";}
  else {$method_descr="Single equation running";}
  print "<tr><td>Method:&nbsp;</td><td>$method_descr</td></tr>\n";
  print "<tr><td></td><td></td></tr>\n";
  print "</table>\n";
  print "<table>\n";
  print "<tr><td><img src=\"../../../imgs/strokes/horizontal/blu/30.gif\"></td><td><i>observed values</i></td></tr>\n";
  print "<tr><td><img src=\"../../../imgs/strokes/horizontal/green/30.gif\"></td><td><i>estimated values</i></td></tr></table>\n";
  print "<table cellspacing=5 border=0>\n";
  print "<tr><td width=60 align=right><b>YEAR</b></td><td width=60 align=right><b>OBS_V</b></td><td width=60 align=right><b>EST_V</b></td><td width=60 align=right><b>ERR</b></td><td width=60 align=right><b>ERR %</b></td><td width=5>&nbsp;</td><td width=200></td></tr>\n";
  $ctr_est_validi=0;
  $ctr_obs_validi=0;
  $ctr_err_validi=0;

$maxvalue1=0;
$maxvalue2=0;
foreach $val (@{$outvar_min}) {
  if ($val > $maxvalue1) {$maxvalue1=$val}
}
foreach $val (@outvar_obs) {
  if ($val > $maxvalue2) {$maxvalue2=$val}
}



  #@outvar_est_temp = sort @{$outvar_min};
  #@outvar_est_temp = reverse @outvar_est_temp;
  #@outvar_obs_temp = sort @outvar_obs;
  #@outvar_obs_temp = reverse @outvar_obs_temp;

  if ($maxvalue1 > $maxvalue2) {$maxvalue = $maxvalue1;}
  else { $maxvalue = $maxvalue2;}

$ctr_all_zero=0;
foreach $val (@{$outvar_min}) {
  if ($val > 0 || $val < 0) {$ctr_all_zero++;}
}
foreach $val (@outvar_obs) {
  if ($val > 0 || $val < 0) {$ctr_all_zero++;}
}
if ($ctr_all_zero==0) {&error('all estimates and observed data are zero for this variable');}

  for ($y=0;$y<($n_years-1);$y++) {
	  $y_xxxx = $y+1979;
	  $est_value = @{$outvar_min}[$y];
	  $ctr_est_not=0;

	 
	  foreach $y_not (@years_not) {
		  if ($y == $y_not) {$ctr_est_not++; last;}
	  }
      # I don't want make a division for zero!
     if ($ctr_est_not == 0 && @outvar_obs[$y] =~ /\d/) {
		  $ctr_est_validi++;
		  $ctr_obs_validi++;
		  $ctr_err_validi++;
		  $err= $est_value-@outvar_obs[$y];
		  if (@outvar_obs[$y] !=0) {
		      $err_perc = 100*($est_value-@outvar_obs[$y])/@outvar_obs[$y];
		  }
		  else {
              $err_perc="N/A";
		 }
		  $tot_obs_values = $tot_obs_values + @outvar_obs[$y];
		  $tot_est_values = $tot_est_values + $est_value;
          $tot_err        = $tot_err + abs($err);
          if (@outvar_obs[$y] !=0) {
		      $tot_err_perc   = $tot_err_perc + abs($err_perc);
		  }
      }
      elsif ($ctr_est_not == 0 && @outvar_obs[$y] !~ /\d/) {
		  $ctr_est_validi++;  
		  $tot_est_values = $tot_est_values + $est_value;	  
		  $err = "N/A";
		  $err_perc  = "N/A";
          @outvar_obs[$y] = "N/A";
	  }
      elsif ($ctr_est_not > 0 && @outvar_obs[$y] =~ /\d/) {
		  $ctr_obs_validi++;
		  $tot_obs_values = $tot_obs_values + @outvar_obs[$y];
		  $err="N/A";
		  $err_perc  ="N/A";
          $est_value ="N/A";
	  }
      else {
          @outvar_obs[$y] = "N/A";
          $est_value ="N/A";
		  $err="N/A";
		  $err_perc  ="N/A";
	  }

      if (@outvar_obs[$y] ne "N/A") {
		 if ($maxvalue != 0) {
		   $value_img_obs = int((@outvar_obs[$y]/$maxvalue)*100)+1;
		   if ($value_img_obs == 101) {$value_img_obs = 100;}
		 }
           @outvar_obs[$y]=@outvar_obs[$y]*100;
           @outvar_obs[$y] = int (@outvar_obs[$y]);
		   @outvar_obs[$y] = @outvar_obs[$y]/100;

	  }
	  else {$value_img_obs = 1;}

	  if ($est_value ne "N/A") {
		 if ($maxvalue != 0) {
            $value_img_est = int(($est_value/$maxvalue)*100)+1;
		    if ($value_img_est == 101) {$value_img_est = 100;}
		 } 
		    $est_value=$est_value*100;
            $est_value = int ($est_value);
		    $est_value = $est_value/100;

	  }
	  else {$value_img_est = 1;}
	  if ($err ne "N/A") {
         $err=$err*100;
         $err = int ($err);
		 $err = $err/100;
	  }

	  if ($err_perc ne "N/A") {
         $err_perc=$err_perc*100;
         $err_perc = int ($err_perc);
		 $err_perc = $err_perc/100;
	  }

      if ($value_img_obs < 1) {$value_img_obs = 1;}
      if ($value_img_est <1) {$value_img_est = 1;}
	  print "<tr><td align=right>$y_xxxx</td><td align=right>@outvar_obs[$y]</td><td align=right><b>$est_value</b></td><td align=right><i>$err</i></td><td align=right><i>$err_perc %</i></td><td>&nbsp;</td>\n";
	  print "<td><img src=\"../../../imgs/strokes/horizontal/blu/${value_img_obs}.gif\">\n";
	  print "<br><img src=\"../../../imgs/strokes/horizontal/green/${value_img_est}.gif\"></td></tr>\n";
  }

  # ora mi occupo della riga finale delle medie!
  if ($ctr_err_validi>0) {
	  $avg_obs_values = $tot_obs_values/$ctr_obs_validi;
	  $avg_est_values = $tot_est_values/$ctr_est_validi;
	  $avg_err = $tot_err/$ctr_err_validi;
      $avg_err_perc = $tot_err_perc/$ctr_err_validi;
  }
  elsif ($ctr_obs_validi>0 && $ctr_est_validi ==0) {
	  $avg_obs_values = $tot_obs_values/$ctr_obs_validi;
	  $avg_est_values = "N/A";
	  $avg_err = "N/A";
      $avg_err_perc = "N/A";
  }
  elsif ($ctr_obs_validi == 0 && $ctr_est_validi > 0) {
	  $avg_obs_values = "N/A";
	  $avg_est_values = $tot_est_values/$ctr_est_validi;
	  $avg_err = "N/A";
      $avg_err_perc = "N/A";
  }
  else {
  	  $avg_obs_values = "N/A";
	  $avg_est_values = "N/A";
	  $avg_err = "N/A";
      $avg_err_perc = "N/A";
  }

  # ora ritocco per avere due soli decimali
	  if ($avg_obs_values ne "N/A") {
         $avg_obs_values = $avg_obs_values*100;
         $avg_obs_values = int ($avg_obs_values);
		 $avg_obs_values = $avg_obs_values/100;
	  }
	  if ($avg_est_values ne "N/A") {
         $avg_est_values = $avg_est_values*100;
         $avg_est_values = int ($avg_est_values);
		 $avg_est_values = $avg_est_values/100;
	  }
	  if ($avg_err ne "N/A") {
         $avg_err = $avg_err*100;
         $avg_err = int ($avg_err);
		 $avg_err = $avg_err/100;
	  }
	  if ($avg_err_perc ne "N/A") {
         $avg_err_perc = $avg_err_perc*100;
         $avg_err_perc = int ($avg_err_perc);
		 $avg_err_perc = $avg_err_perc/100;
	  }


  print "<tr><td align=right><b>AVG</b></td><td align=right><b>$avg_obs_values</b></td><td align=right><b>$avg_est_values</b></td><td align=right><b><i>$avg_err</i></b></td><td align=right><b><i>$avg_err_perc %</i></b></td><td align=right></td><td></td><td></td></tr>\n";
  print "</table>\n";
  print "<p>&nbsp;<table>\n";
  print "<tr><td>Data file:&nbsp;</td><td>$file_data</td></tr>\n";
  print "<tr><td>Parameters file:&nbsp;</td><td>$file_parameters</td></tr>\n";
  print "<tr><td></td><td><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font></td></tr>\n";
  print "</table>\n";
 # print "<p>TEST:\n";
 # print "<br>\$test: $test\n";
  print "</body></html>\n";
  exit;
}

#####################################################################################
sub error {

        local($error) = @_;
        print "Content-type: text/html\n\n";
        print "<html><head></head><body><br>-------------------------\n";
        print "<br> Error: $error \n";
        print "<br>&nbsp;<br><a href=\"javascript:history.go(-1);\">&lt;&lt;Back</a>\n";
        print "</body></html>\n";
        exit;
}
# EOF


