#!perl

# $what= "\\*sugarbeet";

# Italian model for the AG-MEMOD project


&get_input;
&load_files;
&run_model;
&html_out;

#####################################################################
sub get_input {
use CGI qw(:standard);
    $query = new CGI;
	$country = $query->param('country');
	$what = $query->param('what');

	if ($country eq "Italy") {
      $file_parameters = "../parametri/it_model_parameters.txt";
      $file_data       = "../dati/it_model_data.txt";
      $file_equations  = "../modelli_grezzi/it_model.eq";
      $model_title     = "Italian Model";
      $comment_key     = "\\*";
      $comment_elast   = "\\#";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
      $end_commodity_flag   = "\\*\\*\\*\\*\\*\\*";
	}

	if ($country eq "EU11_OliveOilDemand") {
      $file_parameters = "../parametri/eu11_model_parameters.txt";
      $file_data       = "../dati/eu11_model_data.txt";
      $file_equations  = "../modelli_grezzi/eu11_model.eq";
      $model_title     = "EU11 Olive Oil Demand";
      $comment_key     = "\\*";
      $comment_elast   = "\\#";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
      $end_commodity_flag   = "\\*\\*\\*\\*\\*\\*";
	}

}
#################################################################
sub load_files {
	#Open data database
    open (DATA, "<$file_data");
    @hisdatas1=(<DATA>);
    close DATA;
	@testone = @hisdatas1;

	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $hisdata(@hisdatas1){
          if ($hisdata ne "\n") {
			 # I remove all the blanks
             $hisdata =~ s/ //g;
		     # I change the commas, if presents, with the dot
             if ($data_delimiter ne ",") {$hisdata =~ s/,/./g;}
		     # I change all the letters in lower case
             $hisdata =~ tr/A-Z/a-z/;
             @dat = split (/$data_delimiter/, $hisdata);
	           if (@dat[0] !~ /$comment_key/ && @dat[0] ne "") {
                    push @hisdatas, $hisdata;
	            }
			}
          }

    # I load the data
    foreach $hisdata(@hisdatas){
       @dat = split (/$data_delimiter/, $hisdata);
	      $n_values = scalar (@dat); 
		  $i=1;
		  while ($i<$n_values) {
             push @{@dat[0]}, @dat[$i];
			 $nome_var_osservata= "@dat[0]"."_observed";
			 push @{$nome_var_osservata}, @dat[$i];
			 $i++;
		  }
    }

    #Open equation model
    open (EQUAZ, "<$file_equations");
    @equations1=(<EQUAZ>);
    close EQUAZ;
	  
	   #controllo che sia la parte del modello richiesta
	   if ($what eq "all_equations") {$ctr_what = 1;}
	   else {$ctr_what = 0;}
	   
	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $riga(@equations1){
          if ($riga ne "\n") {
		    # I remove all the blanks
            $riga =~ s/ //g;
		    # I remove all the comments key for the elasticity calculation
            $riga =~ s/$comment_elast//g;
 		    # I change all the letters in lower case
            $riga =~ tr/A-Z/a-z/;
			# Cerco l'inizio della commodity da cercare
		    if ($riga =~ /$what/ ) {$ctr_what++;}
			# Verifico la fine della commodity
		    if ($riga =~ /$end_commodity_flag/ && $what ne "all_equations" ) {$ctr_what = 0;}
            @dat = split (/\=/, $riga);
	           if (@dat[0] !~ /$comment_key/ && $ctr_what > 0) {
					push @endog_names, @dat[0];
	            }
		  }
      }

}

######################################################################
sub run_model {

    $n_years = scalar @year;

    # all_y: $ystart_xxxx = @year[0];
    $ystart_xxxx = 1995;

	$yend_xxxx = @year[$n_years-1];
	#$outvar_min = $outvar;
	#$outvar_min =~ tr/A-Z/a-z/;
	#$outvar_testeq = "$outvar_min"."_est";
	#@outvar_obs = @{$outvar_min};

	# all_y: for ($y=0;$y<($n_years-1);$y++) {
	for ($y=16;$y<($n_years-1);$y++) {

<<INSERT-HERE>>

	}
	# if (@{$outvar_testeq}) {$outvar_min = $outvar_testeq;}
}

##########################################################################
sub html_out {
  print "Content-type: text/html\n\n";
  print "<html><body>\n";
  print "<hr><b><font size=+1>AG-MEMOD - $model_title\n";
  print "<br>Output of the model</font></b><br>&nbsp;\n";
  print "<table>\n";
  print "<tr><td>Country:&nbsp;</td><td>$country</td></tr>\n";
  if ($method eq "all") {$method_descr="Simultaneous running";}
  else {$method_descr="Single equation running";}
  print "<tr><td>Method:&nbsp;</td><td>$method_descr</td></tr>\n";
  $what =~ s/\\//gi;
  $what =~ s/\*//gi;
  $what =~ tr/a-z/A-Z/;

  print "<tr><td>Commodity:&nbsp;</td><td><font size= +1><b>$what</b></font></td></tr>\n";
  print "</table>\n";
  print "<table>\n";
  print "<tr><td><img src=\"blu/30.gif\"></td><td><i>observed values</i></td></tr>\n";
  print "<tr><td><img src=\"green/30.gif\"></td><td><i>estimated values</i></td></tr></table>\n";
#   print "<tr><td><img src=\"../../../imgs/strokes/horizontal/blu/30.gif\"></td><td><i>observed values</i></td></tr>\n";
#   print "<tr><td><img src=\"../../../imgs/strokes/horizontal/green/30.gif\"></td><td><i>estimated values</i></td></tr><table>\n";

  print "<i>Please note that when all the estimated values are equal to the observed ones, it means that the equation is an identity</i>\n";
  print "<hr>&nbsp;\n";
  $n_variabili = scalar @endog_names;
  $count_var=0;
foreach $outvar (@endog_names) {
	$count_var++;
	$outvar_min = $outvar;
	$outvar_min =~ tr/A-Z/a-z/;
	$outvar_maiuscolo = $outvar;
    $outvar_maiuscolo  =~ tr/a-z/A-Z/;
	$outvar_testeq = "$outvar_min"."_est";
	$nome_var_stimata = "$outvar_min"."_observed";
	@outvar_obs = @{$nome_var_stimata};
	if (@{$outvar_testeq}) {$outvar_min = $outvar_testeq;}
  print "<br>($count_var / $n_variabili)&nbsp;<b>Variable: <font color=red>$outvar_maiuscolo</font>&nbsp;\n";
  if ( ! @{$outvar_testeq} && $method eq "single" ) { print "(ID)";}
  print "</b>\n";
  print "<table cellspacing=5 border=0>\n";
  print "<tr><td width=60 align=right><b>YEAR</b></td><td width=60 align=right><b>OBS_V</b></td><td width=60 align=right><b>EST_V</b></td><td width=60 align=right><b>ERR</b></td><td width=60 align=right><b>ERR %</b></td><td width=5>&nbsp;</td><td width=200></td></tr>\n";
  
  #alcune variabili che devono essere resettate per ogni ciclo

  $ctr_est_validi=0;
  $ctr_obs_validi=0;
  $ctr_err_validi=0;
  $tot_est_values=0;
  $tot_obs_values=0;
  $tot_err=0;
  $tot_err_perc=0;

$maxvalue1=0;
$maxvalue2=0;
foreach $val (@{$outvar_min}) {
  if ($val > $maxvalue1) {$maxvalue1=$val}
}
foreach $val (@outvar_obs) {
  if ($val > $maxvalue2) {$maxvalue2=$val}
}



  #@outvar_est_temp = sort @{$outvar_min};
  #@outvar_est_temp = reverse @outvar_est_temp;
  #@outvar_obs_temp = sort @outvar_obs;
  #@outvar_obs_temp = reverse @outvar_obs_temp;

  if ($maxvalue1 > $maxvalue2) {$maxvalue = $maxvalue1;}
  else { $maxvalue = $maxvalue2;}

$ctr_all_zero=0;
foreach $val (@{$outvar_min}) {
  if ($val > 0 || $val < 0) {$ctr_all_zero++;}
}
foreach $val (@outvar_obs) {
  if ($val > 0 || $val < 0) {$ctr_all_zero++;}
}
if ($ctr_all_zero==0) {&error('all estimates and observed data are zero for this variable');}

# all_y:  for ($y=0;$y<($n_years-1);$y++) {
  for ($y=16;$y<($n_years-1);$y++) {

	  $y_xxxx = $y+1979;


	  $est_value = @{$outvar_min}[$y];
	  $ctr_est_not=0;

	 
	  foreach $y_not (@years_not) {
		  if ($y == $y_not) {$ctr_est_not++; last;}
	  }
      # I don't want make a division for zero!
     if ($ctr_est_not == 0 && @outvar_obs[$y] =~ /\d/) {
		  $ctr_est_validi++;
		  $ctr_obs_validi++;
		  $ctr_err_validi++;
		  $err= $est_value-@outvar_obs[$y];
		  if (@outvar_obs[$y] !=0) {
		      $err_perc = 100*($est_value-@outvar_obs[$y])/@outvar_obs[$y];
		  }
		  else {
              $err_perc="N/A";
		 }
		  $tot_obs_values = $tot_obs_values + @outvar_obs[$y];
		  $tot_est_values = $tot_est_values + $est_value;
          $tot_err        = $tot_err + abs($err);
          if (@outvar_obs[$y] !=0) {
		      $tot_err_perc   = $tot_err_perc + abs($err_perc);
		  }
      }
      elsif ($ctr_est_not == 0 && @outvar_obs[$y] !~ /\d/) {
		  $ctr_est_validi++;  
		  $tot_est_values = $tot_est_values + $est_value;	  
		  $err = "N/A";
		  $err_perc  = "N/A";
          @outvar_obs[$y] = "N/A";
	  }
      elsif ($ctr_est_not > 0 && @outvar_obs[$y] =~ /\d/) {
		  $ctr_obs_validi++;
		  $tot_obs_values = $tot_obs_values + @outvar_obs[$y];
		  $err="N/A";
		  $err_perc  ="N/A";
          $est_value ="N/A";
	  }
      else {
          @outvar_obs[$y] = "N/A";
          $est_value ="N/A";
		  $err="N/A";
		  $err_perc  ="N/A";
	  }

      if (@outvar_obs[$y] ne "N/A") {
		 if ($maxvalue != 0) {
		   $value_img_obs = int((@outvar_obs[$y]/$maxvalue)*100)+1;
		   if ($value_img_obs == 101) {$value_img_obs = 100;}
		 }
           @outvar_obs[$y]=@outvar_obs[$y]*100;
           @outvar_obs[$y] = int (@outvar_obs[$y]);
		   @outvar_obs[$y] = @outvar_obs[$y]/100;

	  }
	  else {$value_img_obs = 1;}

	  if ($est_value ne "N/A") {
		 if ($maxvalue != 0) {
            $value_img_est = int(($est_value/$maxvalue)*100)+1;
		    if ($value_img_est == 101) {$value_img_est = 100;}
		 } 
		    $est_value=$est_value*100;
            $est_value = int ($est_value);
		    $est_value = $est_value/100;

	  }
	  else {$value_img_est = 1;}
	  if ($err ne "N/A") {
         $err=$err*100;
         $err = int ($err);
		 $err = $err/100;
	  }

	  if ($err_perc ne "N/A") {
         $err_perc=$err_perc*100;
         $err_perc = int ($err_perc);
		 $err_perc = $err_perc/100;
	  }
      if ($value_img_obs < 1) {$value_img_obs = 1;}
      if ($value_img_est <1) {$value_img_est = 1;}

	  print "<tr><td align=right>$y_xxxx</td><td align=right>@outvar_obs[$y]</td><td align=right><b>$est_value</b></td><td align=right><i>$err</i></td><td align=right><i>$err_perc %</i></td><td>&nbsp;</td>\n";
	#  print "<td><img src=\"../../../imgs/strokes/horizontal/blu/${value_img_obs}.gif\">\n";
	#  print "<br><img src=\"../../../imgs/strokes/horizontal/green/${value_img_est}.gif\"></td></tr>\n";
	  print "<td><img src=\"blu/${value_img_obs}.gif\">\n";
	  print "<br><img src=\"green/${value_img_est}.gif\"></td></tr>\n";

  }

  # ora mi occupo della riga finale delle medie!
  if ($ctr_err_validi>0) {
	  $avg_obs_values = $tot_obs_values/$ctr_obs_validi;
	  $avg_est_values = $tot_est_values/$ctr_est_validi;
	  $avg_err = $tot_err/$ctr_err_validi;
      $avg_err_perc = $tot_err_perc/$ctr_err_validi;
  }
  elsif ($ctr_obs_validi>0 && $ctr_est_validi ==0) {
	  $avg_obs_values = $tot_obs_values/$ctr_obs_validi;
	  $avg_est_values = "N/A";
	  $avg_err = "N/A";
      $avg_err_perc = "N/A";
  }
  elsif ($ctr_obs_validi == 0 && $ctr_est_validi > 0) {
	  $avg_obs_values = "N/A";
	  $avg_est_values = $tot_est_values/$ctr_est_validi;
	  $avg_err = "N/A";
      $avg_err_perc = "N/A";
  }
  else {
  	  $avg_obs_values = "N/A";
	  $avg_est_values = "N/A";
	  $avg_err = "N/A";
      $avg_err_perc = "N/A";
  }

  # ora ritocco per avere due soli decimali
	  if ($avg_obs_values ne "N/A") {
         $avg_obs_values = $avg_obs_values*100;
         $avg_obs_values = int ($avg_obs_values);
		 $avg_obs_values = $avg_obs_values/100;
	  }
	  if ($avg_est_values ne "N/A") {
         $avg_est_values = $avg_est_values*100;
         $avg_est_values = int ($avg_est_values);
		 $avg_est_values = $avg_est_values/100;
	  }
	  if ($avg_err ne "N/A") {
         $avg_err = $avg_err*100;
         $avg_err = int ($avg_err);
		 $avg_err = $avg_err/100;
	  }
	  if ($avg_err_perc ne "N/A") {
         $avg_err_perc = $avg_err_perc*100;
         $avg_err_perc = int ($avg_err_perc);
		 $avg_err_perc = $avg_err_perc/100;
	  }


  print "<tr><td align=right><b>AVG</b></td><td align=right><b>$avg_obs_values</b></td><td align=right><b>$avg_est_values</b></td><td align=right><b><i>$avg_err</i></b></td><td align=right><b><i>$avg_err_perc %</i></b></td><td align=right></td><td></td><td></td></tr>\n";
  print "</table>\n";


 }
  print "<br>Model runned with the $ENV{'SCRIPT_NAME'} perl script.\n";
  print "<br>UNIAN team: <a href=\"mailto:robertoe@dea.unian.it\">Roberto Esposti</a>, <a href=\"mailto:berloni@dea.unian.it\">Davide Berloni</a>, <a href=\"mailto:lobianco@dea.unian.it\">Antonello Lobianco</a>\n";
  print "</body></html>\n";
  exit;
}

#####################################################################################
sub error {

        local($error) = @_;
        print "Content-type: text/html\n\n";
        print "<html><head></head><body><br>-------------------------\n";
        print "<br> Error: $error \n";
        print "<br>&nbsp;<br><a href=\"javascript:history.go(-1);\">&lt;&lt;Back</a>\n";
        print "</body></html>\n";
        exit;
}
# EOF


