#!perl

# Italian model for the AG-MEMOD project


&get_input;
&load_files;
&run_model;
&html_out;

#####################################################################
sub get_input {
use CGI qw(:standard);
    $query = new CGI;
	$country = $query->param('country');
	$ystart = 16;
	$yend   = 22;

	if ($country eq "Italy") {
      $file_parameters = "../parametri/it_model_parameters.txt";
      $file_data       = "../dati/it_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	  $model_title     = "Italian Model";
	}
	if ($country eq "EU11_OliveOilDemand") {
      $file_parameters = "../parametri/eu11_model_parameters.txt";
      $file_data       = "../dati/eu11_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	  $model_title     = "EU11 Olive Oil and Fats demand model";
	}

}

#################################################################
sub load_files {
	#Open data database
    open (DATA, "<$file_data");
    @hisdatas1=(<DATA>);
    close DATA;
	@testone = @hisdatas1;

	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $hisdata(@hisdatas1){
          if ($hisdata ne "\n") {
			 # I remove all the blanks
             $hisdata =~ s/ //g;
		     # I change the commas, if presents, with the dot
             if ($data_delimiter ne ",") {$hisdata =~ s/,/./g;}
		     # I change all the letters in lower case
             $hisdata =~ tr/A-Z/a-z/;
             @dat = split (/$data_delimiter/, $hisdata);
	           if (@dat[0] !~ /$comment_key/) {
                    push @hisdatas, $hisdata;
	            }
			}
          }

    # I load the data
    foreach $hisdata(@hisdatas){
       @dat = split (/$data_delimiter/, $hisdata);
	      $n_values = scalar (@dat); 
		  $i=1;
		  while ($i<$n_values) {
             push @{@dat[0]}, @dat[$i];
			 $i++;
		  }
    }
}

######################################################################
sub run_model {

    $ystart_xxxx = $ystart+1979;
	$yend_xxxx = $yend+1978;
    
for ($y=$ystart; $y<$yend;$y++){
if ( @rgdpc11[$y] !~ /\d/ ) {next; }
if ( @trend70[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @ofexp11[$y];
$sum_x0 = $sum_x0 + @trend70[$y];
$sum_x1 = $sum_x1 + @rgdpc11[$y];
}
if ($sum_y != 0){
   $elast_name   = "trend70";
   $elast_param  = -4.76615;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "ofexp11$elast_name$elast_value";
   $elast_name   = "rgdpc11";
   $elast_param  = 0.00625391;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "ofexp11$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @bupwr11[$y] !~ /\d/ ) {next; }
if ( @ofexp11[$y] !~ /\d/ ) {next; }
if ( @olpwr11[$y] !~ /\d/ ) {next; }
if ( @ropwr11[$y] !~ /\d/ ) {next; }
if ( @sopwr11[$y] !~ /\d/ ) {next; }
if ( @uopwr11[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @loludc11[$y];
$sum_x0 = $sum_x0 + log(@olpwr11[$y]);
$sum_x1 = $sum_x1 + log(@ropwr11[$y]);
$sum_x2 = $sum_x2 + log(@uopwr11[$y]);
$sum_x3 = $sum_x3 + log(@sopwr11[$y]);
$sum_x4 = $sum_x4 + log(@bupwr11[$y]);
$sum_x5 = $sum_x5 + log(@ofexp11[$y]);
}
if ($sum_y != 0){
   $elast_name   = "log(olpwr11)";
   $elast_param  = -1.28177;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "loludc11$elast_name$elast_value";
   $elast_name   = "log(ropwr11)";
   $elast_param  = -1.22855;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "loludc11$elast_name$elast_value";
   $elast_name   = "log(uopwr11)";
   $elast_param  = -0.499246;
   $elast_value  = $elast_param*($sum_x2/$sum_y);
   push @elastdb, "loludc11$elast_name$elast_value";
   $elast_name   = "log(sopwr11)";
   $elast_param  = -0.00705795;
   $elast_value  = $elast_param*($sum_x3/$sum_y);
   push @elastdb, "loludc11$elast_name$elast_value";
   $elast_name   = "log(bupwr11)";
   $elast_param  = 3.01662395;
   $elast_value  = $elast_param*($sum_x4/$sum_y);
   push @elastdb, "loludc11$elast_name$elast_value";
   $elast_name   = "log(ofexp11)";
   $elast_param  = 0.015429;
   $elast_value  = $elast_param*($sum_x5/$sum_y);
   push @elastdb, "loludc11$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_x2=0;
$sum_x3=0;
$sum_x4=0;
$sum_x5=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @loludc11[$y] !~ /\d/ ) {next; }
@oludc11[$y]=exp(@loludc11[$y])
;
}
for ($y=$ystart; $y<$yend;$y++){
if ( @bupwr11[$y] !~ /\d/ ) {next; }
if ( @ofexp11[$y] !~ /\d/ ) {next; }
if ( @olpwr11[$y] !~ /\d/ ) {next; }
if ( @ropwr11[$y] !~ /\d/ ) {next; }
if ( @sopwr11[$y] !~ /\d/ ) {next; }
if ( @uopwr11[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @lroudc11[$y];
$sum_x0 = $sum_x0 + log(@olpwr11[$y]);
$sum_x1 = $sum_x1 + log(@ropwr11[$y]);
$sum_x2 = $sum_x2 + log(@uopwr11[$y]);
$sum_x3 = $sum_x3 + log(@sopwr11[$y]);
$sum_x4 = $sum_x4 + log(@bupwr11[$y]);
$sum_x5 = $sum_x5 + log(@ofexp11[$y]);
}
if ($sum_y != 0){
   $elast_name   = "log(olpwr11)";
   $elast_param  = -1.22855;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "lroudc11$elast_name$elast_value";
   $elast_name   = "log(ropwr11)";
   $elast_param  = -2.16712;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "lroudc11$elast_name$elast_value";
   $elast_name   = "log(uopwr11)";
   $elast_param  = -1.55835;
   $elast_value  = $elast_param*($sum_x2/$sum_y);
   push @elastdb, "lroudc11$elast_name$elast_value";
   $elast_name   = "log(sopwr11)";
   $elast_param  = 1.48424;
   $elast_value  = $elast_param*($sum_x3/$sum_y);
   push @elastdb, "lroudc11$elast_name$elast_value";
   $elast_name   = "log(bupwr11)";
   $elast_param  = 3.46978;
   $elast_value  = $elast_param*($sum_x4/$sum_y);
   push @elastdb, "lroudc11$elast_name$elast_value";
   $elast_name   = "log(ofexp11)";
   $elast_param  = 0.579795;
   $elast_value  = $elast_param*($sum_x5/$sum_y);
   push @elastdb, "lroudc11$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_x2=0;
$sum_x3=0;
$sum_x4=0;
$sum_x5=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @lroudc11[$y] !~ /\d/ ) {next; }
@roudc11[$y]=exp(@lroudc11[$y])
;
}
for ($y=$ystart; $y<$yend;$y++){
if ( @bupwr11[$y] !~ /\d/ ) {next; }
if ( @ofexp11[$y] !~ /\d/ ) {next; }
if ( @olpwr11[$y] !~ /\d/ ) {next; }
if ( @ropwr11[$y] !~ /\d/ ) {next; }
if ( @sopwr11[$y] !~ /\d/ ) {next; }
if ( @uopwr11[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @luoudc11[$y];
$sum_x0 = $sum_x0 + log(@olpwr11[$y]);
$sum_x1 = $sum_x1 + log(@ropwr11[$y]);
$sum_x2 = $sum_x2 + log(@uopwr11[$y]);
$sum_x3 = $sum_x3 + log(@sopwr11[$y]);
$sum_x4 = $sum_x4 + log(@bupwr11[$y]);
$sum_x5 = $sum_x5 + log(@ofexp11[$y]);
}
if ($sum_y != 0){
   $elast_name   = "log(olpwr11)";
   $elast_param  = -0.499246;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "luoudc11$elast_name$elast_value";
   $elast_name   = "log(ropwr11)";
   $elast_param  = -1.55835;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "luoudc11$elast_name$elast_value";
   $elast_name   = "log(uopwr11)";
   $elast_param  = -0.453789;
   $elast_value  = $elast_param*($sum_x2/$sum_y);
   push @elastdb, "luoudc11$elast_name$elast_value";
   $elast_name   = "log(sopwr11)";
   $elast_param  = 0.349525;
   $elast_value  = $elast_param*($sum_x3/$sum_y);
   push @elastdb, "luoudc11$elast_name$elast_value";
   $elast_name   = "log(bupwr11)";
   $elast_param  = 2.16186;
   $elast_value  = $elast_param*($sum_x4/$sum_y);
   push @elastdb, "luoudc11$elast_name$elast_value";
   $elast_name   = "log(ofexp11)";
   $elast_param  = 0.842236;
   $elast_value  = $elast_param*($sum_x5/$sum_y);
   push @elastdb, "luoudc11$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_x2=0;
$sum_x3=0;
$sum_x4=0;
$sum_x5=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @luoudc11[$y] !~ /\d/ ) {next; }
@uoudc11[$y]=exp(@luoudc11[$y])
;
}
for ($y=$ystart; $y<$yend;$y++){
if ( @bupwr11[$y] !~ /\d/ ) {next; }
if ( @ofexp11[$y] !~ /\d/ ) {next; }
if ( @olpwr11[$y] !~ /\d/ ) {next; }
if ( @ropwr11[$y] !~ /\d/ ) {next; }
if ( @sopwr11[$y] !~ /\d/ ) {next; }
if ( @uopwr11[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @lsoudc11[$y];
$sum_x0 = $sum_x0 + log(@olpwr11[$y]);
$sum_x1 = $sum_x1 + log(@ropwr11[$y]);
$sum_x2 = $sum_x2 + log(@uopwr11[$y]);
$sum_x3 = $sum_x3 + log(@sopwr11[$y]);
$sum_x4 = $sum_x4 + log(@bupwr11[$y]);
$sum_x5 = $sum_x5 + log(@ofexp11[$y]);
}
if ($sum_y != 0){
   $elast_name   = "log(olpwr11)";
   $elast_param  = -0.00705795;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "lsoudc11$elast_name$elast_value";
   $elast_name   = "log(ropwr11)";
   $elast_param  = 1.48424;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "lsoudc11$elast_name$elast_value";
   $elast_name   = "log(uopwr11)";
   $elast_param  = 0.349525;
   $elast_value  = $elast_param*($sum_x2/$sum_y);
   push @elastdb, "lsoudc11$elast_name$elast_value";
   $elast_name   = "log(sopwr11)";
   $elast_param  = -2.8339;
   $elast_value  = $elast_param*($sum_x3/$sum_y);
   push @elastdb, "lsoudc11$elast_name$elast_value";
   $elast_name   = "log(bupwr11)";
   $elast_param  = 1.00719295;
   $elast_value  = $elast_param*($sum_x4/$sum_y);
   push @elastdb, "lsoudc11$elast_name$elast_value";
   $elast_name   = "log(ofexp11)";
   $elast_param  = 1.16224;
   $elast_value  = $elast_param*($sum_x5/$sum_y);
   push @elastdb, "lsoudc11$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_x2=0;
$sum_x3=0;
$sum_x4=0;
$sum_x5=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @lsoudc11[$y] !~ /\d/ ) {next; }
@soudc11[$y]=exp(@lsoudc11[$y])
;
}
for ($y=$ystart; $y<$yend;$y++){
if ( @bupwr11[$y] !~ /\d/ ) {next; }
if ( @ofexp11[$y] !~ /\d/ ) {next; }
if ( @olpwr11[$y] !~ /\d/ ) {next; }
if ( @oludc11[$y] !~ /\d/ ) {next; }
if ( @pop11[$y] !~ /\d/ ) {next; }
if ( @ropwr11[$y] !~ /\d/ ) {next; }
if ( @roudc11[$y] !~ /\d/ ) {next; }
if ( @sopwr11[$y] !~ /\d/ ) {next; }
if ( @soudc11[$y] !~ /\d/ ) {next; }
if ( @uopwr11[$y] !~ /\d/ ) {next; }
if ( @uoudc11[$y] !~ /\d/ ) {next; }
@buufd11[$y]=(@ofexp11[$y]*@pop11[$y]-@olpwr11[$y]*@oludc11[$y]-@ropwr11[$y]*@roudc11[$y]-@uopwr11[$y]*@uoudc11[$y]-@sopwr11[$y]*@soudc11[$y])/@bupwr11[$y]
;
}
	
}
##########################################################################
sub html_out {
  print "Content-type: text/html\n\n";
  print "<html><body>\n";
  print "<hr>AG-MEMOD - $model_title - Average Elasticity Calculation<br><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font><br><hr>\n";
  print "<table>\n";
  print "<tr><td>Country:&nbsp;</td><td>$country</td></tr>\n";
  print "<tr><td>Periodo considerato:</td><td>$ystart_xxxx - $yend_xxxx</td></tr>\n";
  print "</table>\n";
  if (@test) {
	  print "TEST: @test\n";
  }
  $temp = "";
  print "<table>\n";
  foreach $val (@elastdb) {
	  @dat = split (//, $val);
	  if (@dat[0] ne $temp) {
		  print "</table>\n<p><b>EQUAZIONE:&nbsp;<font color=red>@dat[0]</font></b>\n";
		  print "<table>\n";
	  }
	  print "<tr><td>&nbsp;-&nbsp;@dat[1]:&nbsp;</td><td>@dat[2]</td></tr>\n";
      $temp = @dat[0];
   }
  print "</table>\n";
  print "<p>&nbsp;<table>\n";
  print "<tr><td>Data file:&nbsp;</td><td>$file_data</td></tr>\n";
  print "<tr><td>Parameters file:&nbsp;</td><td>$file_parameters</td></tr>\n";
  print "<tr><td></td><td><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font></td></tr>\n";
  print "</table>\n";
  print "</body></html>\n";
  exit;
}


