#!perl

# Italian model for the AG-MEMOD project


&get_input;
&load_files;
&run_model;
&html_out;

#####################################################################
sub get_input {
use CGI qw(:standard);
    $query = new CGI;
	$country = $query->param('country');
	$ystart = 16;
	$yend   = 22;

	if ($country eq "Italy") {
      $file_parameters = "../parametri/it_model_parameters.txt";
      $file_data       = "../dati/it_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	  $model_title     = "Italian Model";
	}
	if ($country eq "EU11_OliveOilDemand") {
      $file_parameters = "../parametri/eu11_model_parameters.txt";
      $file_data       = "../dati/eu11_model_data.txt";
      $comment_key     = "\\*";
      $par_delimiter   = "\\t";
      $data_delimiter  = "\\t";
	  $model_title     = "EU11 Olive Oil and Fats demand model";
	}

}

#################################################################
sub load_files {
	#Open data database
    open (DATA, "<$file_data");
    @hisdatas1=(<DATA>);
    close DATA;
	@testone = @hisdatas1;

	   #controllo che non sia n una riga bianca n un commento ed elimino gli spazi
       foreach $hisdata(@hisdatas1){
          if ($hisdata ne "\n") {
			 # I remove all the blanks
             $hisdata =~ s/ //g;
		     # I change the commas, if presents, with the dot
             if ($data_delimiter ne ",") {$hisdata =~ s/,/./g;}
		     # I change all the letters in lower case
             $hisdata =~ tr/A-Z/a-z/;
             @dat = split (/$data_delimiter/, $hisdata);
	           if (@dat[0] !~ /$comment_key/ && @dat[0] ne "") {
                    push @hisdatas, $hisdata;
	            }
			}
          }





    # I load the data
    foreach $hisdata(@hisdatas){
       @dat = split (/$data_delimiter/, $hisdata);
	      $n_values = scalar (@dat); 
		  $i=1;
		  while ($i<$n_values) {
             push @{@dat[0]}, @dat[$i];
			 $i++;
		  }
    }
}

######################################################################
sub run_model {

    $ystart_xxxx = $ystart+1979;
	$yend_xxxx = $yend+1978;
    
for ($y=$ystart; $y<$yend;$y++){
if ( @orpfees[$y] !~ /\d/ ) {next; }
if ( @orpfeit[$y-1] !~ /\d/ ) {next; }
$sum_y = $sum_y + @orpfeit[$y];
$sum_x0 = $sum_x0 + @orpfees[$y];
$sum_x1 = $sum_x1 + @orpfeit[$y-1];
}
if ($sum_y != 0){
   $elast_name   = "orpfees";
   $elast_param  = 0.384121;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "orpfeit$elast_name$elast_value";
   $elast_name   = "orpfeit(-1)";
   $elast_param  = 0.628359;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "orpfeit$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @orpf3it[$y] !~ /\d/ ) {next; }
if ( @trend70[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @orahait[$y];
$sum_x0 = $sum_x0 + @orpf3it[$y];
$sum_x1 = $sum_x1 + @trend70[$y];
}
if ($sum_y != 0){
   $elast_name   = "orpf3it";
   $elast_param  = 0.129359;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "orahait$elast_name$elast_value";
   $elast_name   = "trend70";
   $elast_param  = 0.261305;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "orahait$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @orahait[$y] !~ /\d/ ) {next; }
if ( @orpf3it[$y] !~ /\d/ ) {next; }
if ( @oryhait[$y-1] !~ /\d/ ) {next; }
$sum_y = $sum_y + @oryhait[$y];
$sum_x0 = $sum_x0 + @oryhait[$y-1];
$sum_x1 = $sum_x1 + @orpf3it[$y];
$sum_x2 = $sum_x2 + @orahait[$y];
}
if ($sum_y != 0){
   $elast_name   = "oryhait(-1)";
   $elast_param  = -0.369774;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "oryhait$elast_name$elast_value";
   $elast_name   = "orpf3it";
   $elast_param  = 2.12193;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "oryhait$elast_name$elast_value";
   $elast_name   = "orahait";
   $elast_param  = -1.60589;
   $elast_value  = $elast_param*($sum_x2/$sum_y);
   push @elastdb, "oryhait$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_x2=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @orahait[$y] !~ /\d/ ) {next; }
if ( @oryhait[$y] !~ /\d/ ) {next; }
@orsprit[$y]=@oryhait[$y]*@orahait[$y]/10
;
}
for ($y=$ystart; $y<$yend;$y++){
if ( @appfeit[$y] !~ /\d/ ) {next; }
if ( @gdpde5[$y] !~ /\d/ ) {next; }
if ( @orpfrit[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @orudcit[$y];
$sum_x0 = $sum_x0 + @orpfrit[$y];
$sum_x1 = $sum_x1 + (100*@appfeit[$y]/@gdpde5[$y]);
}
if ($sum_y != 0){
   $elast_name   = "orpfrit";
   $elast_param  = -16.2321;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "orudcit$elast_name$elast_value";
   $elast_name   = "(100*appfeit/gdpde5)";
   $elast_param  = 14.0013;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "orudcit$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @orsprit[$y] !~ /\d/ ) {next; }
if ( @orudcit[$y] !~ /\d/ ) {next; }
$sum_y = $sum_y + @oruxtit[$y];
$sum_x0 = $sum_x0 + @orsprit[$y];
$sum_x1 = $sum_x1 + @orudcit[$y];
}
if ($sum_y != 0){
   $elast_name   = "orsprit";
   $elast_param  = 0.817731;
   $elast_value  = $elast_param*($sum_x0/$sum_y);
   push @elastdb, "oruxtit$elast_name$elast_value";
   $elast_name   = "orudcit";
   $elast_param  = -0.769765;
   $elast_value  = $elast_param*($sum_x1/$sum_y);
   push @elastdb, "oruxtit$elast_name$elast_value";
}
$sum_x0=0;
$sum_x1=0;
$sum_y=0;
for ($y=$ystart; $y<$yend;$y++){
if ( @orsprit[$y] !~ /\d/ ) {next; }
if ( @orudcit[$y] !~ /\d/ ) {next; }
if ( @oruxtit[$y] !~ /\d/ ) {next; }
@orumtit[$y]=@orsprit[$y]-@orudcit[$y]-@oruxtit[$y]
;
}
	
}
##########################################################################
sub html_out {
  print "Content-type: text/html\n\n";
  print "<html><body>\n";
  print "<hr>AG-MEMOD - $model_title - Average Elasticity Calculation<br><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font><br><hr>\n";
  print "<table>\n";
  print "<tr><td>Country:&nbsp;</td><td>$country</td></tr>\n";
  print "<tr><td>Periodo considerato:</td><td>$ystart_xxxx - $yend_xxxx</td></tr>\n";
  print "</table>\n";
  if (@test) {
	  print "TEST: @test\n";
  }
  $temp = "";
  print "<table>\n";
  foreach $val (@elastdb) {
	  @dat = split (//, $val);
	  if (@dat[0] ne $temp) {
		  print "</table>\n<p><b>EQUAZIONE:&nbsp;<font color=red>@dat[0]</font></b>\n";
		  print "<table>\n";
	  }
	  print "<tr><td>&nbsp;-&nbsp;@dat[1]:&nbsp;</td><td>@dat[2]</td></tr>\n";
      $temp = @dat[0];
   }
  print "</table>\n";
  print "<p>&nbsp;<table>\n";
  print "<tr><td>Data file:&nbsp;</td><td>$file_data</td></tr>\n";
  print "<tr><td>Parameters file:&nbsp;</td><td>$file_parameters</td></tr>\n";
  print "<tr><td></td><td><font size=-1>[<a href=\"javascript:history.go(-1);\">Back</a>]</font></td></tr>\n";
  print "</table>\n";
  print "</body></html>\n";
  exit;
}


